HC = require 'hardoncollider'
local text = {}
local score = 0
local i = 1

function on_collision(dt, shape_a, shape_b, mtv_x, mtv_y)
	if i<3142 then
		i = i + 1
		love.graphics.draw(cake, cakes[i][1], cakes[i][2])
		score = score + 1
	end
end

function love.load()
	drawtroll = false
    Collider = HC(100, on_collision, collision_stop)
	love.graphics.setMode(650, 500)
	imgx = (love.graphics.getWidth() / 2) - 16
	imgy = (love.graphics.getHeight() / 2) - 16
	trollx = love.graphics.getWidth() / 2
	trolly = love.graphics.getHeight() - 25
	rect = Collider:addRectangle(imgx,imgy,32,32)
	cake = love.graphics.newImage("cake.png")
	pie = love.graphics.newImage("pie.png")
	sandwich = love.graphics.newImage("sandwich.png")
	troll = love.graphics.newImage("troll.png")
	local f = love.graphics.newFont(12)
	love.graphics.setFont(f)
	love.graphics.setBackgroundColor(128, 0, 129)
	
	cakes = {}
	max_cakes = 3142
	for i=1, max_cakes do
		local x = math.random(5, love.graphics.getWidth()-5)
		local y = math.random(5, love.graphics.getHeight()-5)
		cakes[i] = {x, y}
   end
   rect = Collider:addRectangle(cakes[i][1],cakes[i][2],16,16)
end

function love.draw()
	love.graphics.draw(cake, cakes[i][1], cakes[i][2])
	love.graphics.draw(pie, imgx, imgy)
	if drawtroll then
		love.graphics.draw(troll, trollx, trolly)
	end
	love.graphics.print("Use the arrow keys to make the pie get the cakes! Get enough cakes and you will get a surprise!", 0, 0)
	love.graphics.print("Score: " .. score, 0, 20)
end

function love.focus(f) gameIsPaused = not f end

function love.update(dt)
	if gameIsPaused then return end
	rect:moveTo(imgx, imgy)
	Collider:update(dt)
end

function love.keypressed(key, unicode)
	if key == 'q' then
		drawtroll = true
	elseif key == "e" then
		drawtroll = false
	elseif key == 'left' then
		imgx = imgx - 24
	elseif key == 'right' then
		imgx = imgx + 24
	elseif key == 'down' then
		imgy = imgy + 24
	elseif key == 'up' then
		imgy = imgy - 24
	end
end